<?php

class nl2goModel extends oxUBase
{

    public function getCustomerGroups()
    {
        $lang = oxRegistry::getLang()->getLanguageAbbr();

        $sViewName = 'oxv_oxgroups_' . $lang;
        $oDb = oxDb::getDb(oxDb::FETCH_MODE_ASSOC);
        $rs = $oDb->execute('SELECT * FROM ' . $sViewName);
        $result = array();

        while (!$rs->EOF) {
            $rs2 = $oDb->execute("SELECT COUNT(*) AS total FROM oxobject2group WHERE OXOBJECTID NOT LIKE 'oxid%' AND OXGROUPSID='{$rs->fields['OXID']}' ;");
            $result[] = array(
                'id' => $rs->fields['OXID'],
                'name' => $rs->fields['OXTITLE'],
                'description' => null,
                'count' => $rs2->fields['total'],
            );
            $rs->moveNext();
        }

        return $result;
    }

    public function getCustomerFields()
    {
        return array(
            array(
                'id' => 'totalorders',
                'name' => 'Total Orders',
                'description' => 'Count of total orders by customer',
                'type' => 'Integer',
            ),
            array(
                'id' => 'totalrevenue',
                'name' => 'Total Revenue',
                'description' => 'Total revenue of customer',
                'type' => 'Float',
            ),
            array(
                'id' => 'averagecartsize',
                'name' => 'Average cart size',
                'description' => 'Average cart size',
                'type' => 'Float',
            ),
            array(
                'id' => 'lastorder',
                'name' => 'Last order',
                'description' => 'Last order ISO-Date',
                'type' => 'Date',
            ),
            array(
                'id' => 'oxuser.OXID',
                'name' => 'Id.',
                'description' => 'User id',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXACTIVE',
                'name' => 'Active',
                'description' => 'Is active',
                'type' => 'Boolean',
            ),
            array(
                'id' => 'oxuser.OXRIGHTS',
                'name' => 'Rights',
                'description' => 'User rights: user, malladmin',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXSHOPID',
                'name' => 'Shop Id.',
                'description' => 'Shop id (oxshops)',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXUSERNAME',
                'name' => 'Username (E-mail)',
                'description' => 'E-mail address that is used as username',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXPASSWORD',
                'name' => 'Hashed Password',
                'description' => 'Hashed password',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXPASSSALT',
                'name' => 'Password salt',
                'description' => 'Password salt',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXCUSTNR',
                'name' => 'Customer number',
                'description' => 'Customer number',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxuser.OXUSTID',
                'name' => 'VAT Id.',
                'description' => 'VAT ID No.',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXCOMPANY',
                'name' => 'Company',
                'description' => 'Company',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXFNAME',
                'name' => 'First name',
                'description' => 'First name',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXLNAME',
                'name' => 'Last name',
                'description' => 'Last name',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXSTREET',
                'name' => 'Street',
                'description' => 'Street name',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXSTREETNR',
                'name' => 'House number',
                'description' => 'House number',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXADDINFO',
                'name' => 'Additional info',
                'description' => 'Additional info',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXCITY',
                'name' => 'City',
                'description' => 'City name',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXCOUNTRYID',
                'name' => 'Country Id.',
                'description' => 'Country id (oxcountry)',
                'type' => 'String',
            ),
            array(
                'id' => 'oxcountry.OXTITLE',
                'name' => 'Country name',
                'description' => 'Country name',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXSTATEID',
                'name' => 'State Id.',
                'description' => 'State id (oxstates)',
                'type' => 'String',
            ),
            array(
                'id' => 'oxstates.OXTITLE',
                'name' => 'State name',
                'description' => 'State name',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXZIP',
                'name' => 'ZIP code',
                'description' => 'ZIP code',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXFON',
                'name' => 'Phone number',
                'description' => 'Phone number',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXFAX',
                'name' => 'Fax number',
                'description' => 'Fax number',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXSAL',
                'name' => 'Salutation',
                'description' => 'User title (Mr/Mrs)',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXBONI',
                'name' => 'Credit points',
                'description' => 'Credit points',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxuser.OXCREATE',
                'name' => 'Creation time',
                'description' => 'Creation time',
                'type' => 'Date',
            ),
            array(
                'id' => 'oxuser.OXREGISTER',
                'name' => 'Registration time',
                'description' => 'Registration time',
                'type' => 'Date',
            ),
            array(
                'id' => 'oxuser.OXPRIVFON',
                'name' => 'Personal phone number',
                'description' => 'Personal phone number',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXMOBFON',
                'name' => 'Mobile phone number',
                'description' => 'Mobile phone number',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXBIRTHDATE',
                'name' => 'Birthday date',
                'description' => 'Birthday date',
                'type' => 'Date',
            ),
            array(
                'id' => 'oxuser.OXURL',
                'name' => 'Url',
                'description' => 'Url',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXUPDATEKEY',
                'name' => 'Update key',
                'description' => 'Update key',
                'type' => 'String',
            ),
            array(
                'id' => 'oxuser.OXUPDATEEXP',
                'name' => 'Update key expiration time',
                'description' => 'Update key expiration time',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxuser.OXPOINTS',
                'name' => 'Update points',
                'description' => 'User points (for registration, invitation, etc)',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxuser.OXFBID',
                'name' => 'Facebook id',
                'description' => 'Facebook id (used for openid login)',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxuser.OXTIMESTAMP',
                'name' => 'Last modified on',
                'description' => 'Timestamp of last modification',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxnewssubscribed.OXDBOPTIN',
                'name' => 'Opt in',
                'description' => 'Subscription status: 0 - not subscribed, 1 - subscribed, 2 - not confirmed',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxnewssubscribed.OXEMAILFAILED',
                'name' => 'Email bounce',
                'description' => 'Subscription email sending status',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxnewssubscribed.OXSUBSCRIBED',
                'name' => 'Subscription date',
                'description' => 'Subscription date',
                'type' => 'Date',
            ),
            array(
                'id' => 'oxnewssubscribed.OXUNSUBSCRIBED',
                'name' => 'Unsubscription date',
                'description' => 'Unsubscription date',
                'type' => 'Date',
            ),
        );
    }

    public function getCustomers($params = array())
    {
        $result = array();
        $queryWhere = '';
        $queryLimit = '';
        $conditions = array();

        if ($params['fields']) {
            $fieldIds = json_decode($params['fields'], true);
        } else {
            $fields = $this->getCustomerFields();
            $fieldIds = array();
            foreach ($fields as $field) {
                $fieldIds[] = $field['id'];
            }

            unset($fields);
        }

        $querySelect = $this->createCustomersSelect($fieldIds);
        $queryFrom = ' FROM oxuser 
                        LEFT JOIN oxnewssubscribed ON oxnewssubscribed.OXUSERID = oxuser.OXID 
                        LEFT JOIN oxstates ON oxuser.OXSTATEID = oxstates.OXID 
                        LEFT JOIN oxcountry ON oxuser.OXCOUNTRYID = oxcountry.OXID ';

        if ($params['groups']) {
            $groupIds = json_decode($params['groups'], true);
            $groups = "'" . implode("','", $groupIds) . "'";

            $conditions[] = " oxuser.OXID IN (SELECT oxobject2group.OXOBJECTID FROM oxobject2group WHERE oxobject2group.OXGROUPSID IN ($groups)) ";
        }

        if ($params['subscribed']) {
            $conditions[] = ' oxnewssubscribed.OXDBOPTIN = 1 ';
        }

        if ($params['hours']) {
            $ts = date('Y-m-d H:i:s', time() - 3600 * $params['hours']);
            $conditions[] = " oxuser.OXTIMESTAMP >= '$ts' ";
        }

        if (count($conditions)) {
            $queryWhere = ' WHERE ' . implode('AND', $conditions);
        }

        if ($params['limit']) {
            $limit = $params['limit'];
            $offset = $params['offset'] ? $params['offset'] : 0;
            $queryLimit = "LIMIT $offset, $limit";
        }

        $oDb = oxDb::getDb(oxDb::FETCH_MODE_ASSOC);
        $rsCustomers = $oDb->execute($querySelect . $queryFrom . $queryWhere . $queryLimit);
        $rsTotal = $oDb->execute('SELECT COUNT(*) AS total ' . $queryFrom . $queryWhere);
        $hasId = array_search('oxuser.OXID', $fieldIds) === false;
        
        $orderFields = $this->getOrderSelectFields($fieldIds);
        $queryOrder = 'SELECT ' . implode(', ', $orderFields) . ' FROM oxorder WHERE OXUSERID = ';
        
        while (!$rsCustomers->EOF) {
            $customer = $rsCustomers->fields;
            
            if (!empty($orderFields)) {
                $rsOrder = $oDb->execute($queryOrder . "'" . $customer['oxuser.OXID'] . "'");
                $customer = array_merge($customer, $rsOrder->fields);
            }
            
            if ($hasId) {
                unset($customer['oxuser.OXID']);
            }
            
            $result[] = $customer;
            $rsCustomers->moveNext();
        }

        return array('data' => $result, 'total' => (int) $rsTotal->fields['total']);
    }

    public function unsubscribeCustomer($email)
    {
        $oDb = oxDb::getDb(oxDb::FETCH_MODE_ASSOC);
        $oDb->execute("UPDATE oxnewssubscribed SET OXDBOPTIN = 0 WHERE OXEMAIL=?", array($email));

        return $oDb->Affected_Rows();
    }

    public function bounceEmail($email)
    {
        $oDb = oxDb::getDb(oxDb::FETCH_MODE_ASSOC);
        $oDb->execute("UPDATE oxnewssubscribed SET OXEMAILFAILED = 1 WHERE OXEMAIL=?", array($email));

        return $oDb->Affected_Rows();
    }

    public function getProductInfo($params)
    {
        $result = array();
        
        if ($params['attributes']) {
            $attributeIds = json_decode($params['attributes'], true);
        } else {
            $attributes = $this->getProductAttributes();
            $attributeIds = array();
            foreach ($attributes as $attribute) {
                $attributeIds[] = $attribute['id'];
            }

            unset($attributes);
        }

        $articleView = 'oxv_oxarticles_' . $params['lang'];
        $shopView = 'oxv_oxshops_' . $params['lang'];
        $vendorView = 'oxv_oxvendor_' . $params['lang'];
        $manufView = 'oxv_oxmanufacturers_' . $params['lang'];
        $artextView = 'oxv_oxartextends_' . $params['lang'];

        $querySelect = $this->createProductSelect($attributeIds, $params['lang']);
        $queryWhere = " WHERE $articleView.OXID = '{$params['id']}' OR $articleView.OXARTNUM = '{$params['id']}' ";
        $queryFrom = " FROM $articleView
                            LEFT JOIN $shopView ON $shopView.OXID = $articleView.OXSHOPID 
                            LEFT JOIN $vendorView ON $vendorView.OXID = $articleView.OXVENDORID 
                            LEFT JOIN $manufView ON $manufView.OXID = $articleView.OXMANUFACTURERID 
                            LEFT JOIN $artextView ON $artextView.OXID = $articleView.OXID ";

        $oDb = oxDb::getDb(oxDb::FETCH_MODE_ASSOC);
        $rsProduct = $oDb->execute($querySelect . $queryFrom . $queryWhere);
        $result = $rsProduct->fields;

        $article = oxNew('oxarticle');
        $article->load($result['oxarticles.OXID']);
        if (array_search('oxarticles.OXID', $attributeIds) === false) {
            unset($result['oxarticles.OXID']);
        }

        if (array_search('images', $attributeIds) !== false) {
            $gallery = $article->getPictureGallery();
            $result['images'] = array_values($gallery['Pics']);
        }

        if (array_search('link', $attributeIds) !== false) {
            $linkHelp = oxNew('oxseoencoderarticle');
            $result['link'] = $linkHelp->getArticleUri($article, null);
        }

        if (array_search('vat', $attributeIds) !== false) {
            $result['vat'] = $this->getConfig()->getConfigParam('dDefaultVAT') * 0.01;
        }

        if (array_search('url', $attributeIds) !== false) {
            $result['url'] = $this->getConfig()->getShopUrl();
        }

        $vat = isset($result['oxarticles.OXVAT']) ? $result['oxarticles.OXVAT'] :
                $this->getConfig()->getConfigParam('dDefaultVAT');

        if (isset($result['oldPriceNet']) && $vat) {
            $result['oldPriceNet'] = $result['oldPriceNet'] / (1 + $vat * 0.01);
        }

        if (isset($result['newPriceNet']) && $vat) {
            $result['newPriceNet'] = $result['newPriceNet'] / (1 + $vat * 0.01);
        }

        return $result;
    }

    public function getProductAttributes()
    {
        return array(
            array(
                'id' => 'images',
                'name' => 'Item images',
                'description' => '',
                'type' => 'Array',
            ),
            array(
                'id' => 'link',
                'name' => 'Link to the item',
                'description' => 'Link to the item',
                'type' => 'String',
            ),
            array(
                'id' => 'url',
                'name' => 'Shop URL',
                'description' => 'Shop URL',
                'type' => 'String',
            ),
            array(
                'id' => 'vat',
                'name' => 'Default VAT',
                'description' => 'Default shop VAT',
                'type' => 'Float',
            ),
            array(
                'id' => 'oldPrice',
                'name' => 'Old price',
                'description' => 'Old price',
                'type' => 'Float',
            ),
            array(
                'id' => 'oldPriceNet',
                'name' => 'Old price Net',
                'description' => 'Old price Net',
                'type' => 'Float',
            ),
            array(
                'id' => 'newPriceNet',
                'name' => 'New price Net',
                'description' => 'New price Net',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXID',
                'name' => 'Product Id.',
                'description' => 'Product Id.',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXSHOPID',
                'name' => 'Shop id',
                'description' => 'Shop id (oxshops)',
                'type' => 'String',
            ),
            array(
                'id' => 'oxshops.OXNAME',
                'name' => 'Shop name',
                'description' => 'Shop name',
                'type' => 'String',
            ),
            array(
                'id' => 'oxartextends.OXLONGDESC',
                'name' => 'Long description',
                'description' => 'Long description',
                'type' => 'String',
            ),
            array(
                'id' => 'oxartextends.OXTAGS',
                'name' => 'Tags',
                'description' => 'Tags',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXPARENTID',
                'name' => 'Parent article id',
                'description' => 'Parent article id',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXACTIVE',
                'name' => 'Active',
                'description' => 'Active',
                'type' => 'Boolean',
            ),
            array(
                'id' => 'oxarticles.OXACTIVEFROM',
                'name' => 'Active from',
                'description' => 'Active from specified date',
                'type' => 'Date',
            ),
            array(
                'id' => 'oxarticles.OXACTIVETO',
                'name' => 'Active to',
                'description' => 'Active to specified date',
                'type' => 'Date',
            ),
            array(
                'id' => 'oxarticles.OXARTNUM',
                'name' => 'Article number',
                'description' => 'Article number',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXEAN',
                'name' => 'EAN',
                'description' => 'International Article Number (EAN)',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXDISTEAN',
                'name' => 'Manufacture EAN',
                'description' => 'Manufacture International Article Number (Man. EAN)',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXMPN',
                'name' => 'MPN',
                'description' => 'Manufacture Part Number (MPN)',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXTITLE',
                'name' => 'Title',
                'description' => 'Title',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXSHORTDESC',
                'name' => 'Short description',
                'description' => 'Short description',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXPRICE',
                'name' => 'Article Price',
                'description' => 'Article Price',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXBLFIXEDPRICE',
                'name' => 'No promotions',
                'description' => 'No Promotions (Price Alert)',
                'type' => 'Boolean',
            ),
            array(
                'id' => 'oxarticles.OXPRICEA',
                'name' => 'Price A',
                'description' => 'Price A',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXPRICEA',
                'name' => 'Price B',
                'description' => 'Price B',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXPRICEA',
                'name' => 'Price C',
                'description' => 'Price C',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXBPRICE',
                'name' => 'Purchase Price',
                'description' => 'Purchase Price',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXTPRICE',
                'name' => 'RRP',
                'description' => 'Recommended Retail Price (RRP)',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXUNITNAME',
                'name' => 'Unit name',
                'description' => 'Unit name (kg,g,l,cm etc), used in setting price per quantity unit calculation',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXUNITQUANTITY',
                'name' => 'Article quantity',
                'description' => 'Article quantity, used in setting price per quantity unit calculation',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXEXTURL',
                'name' => 'External URL',
                'description' => 'External URL to other information about the article',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXURLDESC',
                'name' => 'Text for external URL ',
                'description' => 'Text for external URL ',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXURLIMG',
                'name' => 'External URL image',
                'description' => 'External URL image',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXVAT',
                'name' => 'Specific VAT',
                'description' => 'Value added tax. If specified, used in all calculations instead of global vat',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXWEIGHT',
                'name' => 'Weight',
                'description' => 'Weight (kg)',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXSTOCK',
                'name' => 'Stock quantity',
                'description' => 'Article quantity in stock',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXSTOCKFLAG',
                'name' => 'Delivery Status',
                'description' => 'Delivery Status: 1 - Standard, 2 - If out of Stock, offline, 3 - If out of Stock, not orderable, 4 - External Storehouse',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxarticles.OXSTOCKTEXT',
                'name' => 'Message in stock',
                'description' => 'Message, which is shown if the article is in stock',
                'type' => '',
            ),
            array(
                'id' => 'oxarticles.OXDELIVERY',
                'name' => 'Delivery date',
                'description' => 'Date, when the product will be available again if it is sold out',
                'type' => 'Date',
            ),
            array(
                'id' => 'oxarticles.OXINSERT',
                'name' => 'Insert time',
                'description' => 'Insert time',
                'type' => 'Date',
            ),
            array(
                'id' => 'oxarticles.OXTIMESTAMP',
                'name' => 'Last modified on',
                'description' => 'Timestamp of last modification',
                'type' => 'Date',
            ),
            array(
                'id' => 'oxarticles.OXLENGTH',
                'name' => 'Length',
                'description' => 'Article dimensions: Length',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXWIDTH',
                'name' => 'Width',
                'description' => 'Article dimensions: Width',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXHEIGHT',
                'name' => 'Height',
                'description' => 'Article dimensions: Height',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXFILE',
                'name' => 'Media file',
                'description' => 'File, shown in article media list',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXSEARCHKEYS',
                'name' => 'Search terms',
                'description' => 'Search terms',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXQUESTIONEMAIL',
                'name' => 'E-mail for question',
                'description' => 'E-mail for question',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXISSEARCH',
                'name' => 'Searchable',
                'description' => 'Should article be shown in search',
                'type' => 'Boolean',
            ),
            array(
                'id' => 'oxarticles.OXISCONFIGURABLE',
                'name' => 'Configurable',
                'description' => 'Can article be customized',
                'type' => 'Boolean',
            ),
            array(
                'id' => 'oxarticles.OXVARNAME',
                'name' => 'Variant lists',
                'description' => 'Name of variants selection lists (different lists are separated by | )',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXVARSTOCK',
                'name' => 'Active article variants',
                'description' => 'Sum of active article variants stock quantity',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxarticles.OXVARCOUNT',
                'name' => 'Number of variants',
                'description' => 'Total number of variants that article has (active and inactive)',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxarticles.OXVARSELECT',
                'name' => 'Variant article selections',
                'description' => 'Variant article selections (separated by | )',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXVARMINPRICE',
                'name' => 'Lowest price',
                'description' => 'Lowest price in active article variants',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXVARMAXPRICE',
                'name' => 'Highest price',
                'description' => 'Lowest price in active article variants',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXBUNDLEID',
                'name' => 'Bundled article id',
                'description' => 'Bundled article id',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXFOLDER',
                'name' => 'Folder',
                'description' => 'Folder',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXSUBCLASS',
                'name' => 'Subclass',
                'description' => 'Subclass',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXSORT',
                'name' => 'Sorting',
                'description' => 'Sorting',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxarticles.OXSOLDAMOUNT',
                'name' => 'Amount of sold articles',
                'description' => 'Amount of sold articles including variants (used only for parent articles)',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXNONMATERIAL',
                'name' => 'Intangible article',
                'description' => 'Intangible article, free shipping is used (variants inherits parent setting)',
                'type' => 'Boolean',
            ),
            array(
                'id' => 'oxarticles.OXFREESHIPPING',
                'name' => 'Free shiping',
                'description' => 'Free shipping (variants inherits parent setting',
                'type' => 'Boolean',
            ),
            array(
                'id' => 'oxarticles.OXREMINDACTIVE',
                'name' => 'Remind email',
                'description' => 'Enables sending of notification email when oxstock field value falls below oxremindamount value',
                'type' => 'Boolean',
            ),
            array(
                'id' => 'oxarticles.OXREMINDAMOUNT',
                'name' => 'Remind amount',
                'description' => 'Defines the amount, below which notification email will be sent if oxremindactive is set to 1',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXVENDORID',
                'name' => 'Vendor id',
                'description' => 'Vendor id (oxvendor)',
                'type' => 'String',
            ),
            array(
                'id' => 'oxvendor.OXTITLE',
                'name' => 'Vendor name',
                'description' => 'Vendor name',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXMANUFACTURERID',
                'name' => 'Manufacturer id',
                'description' => 'Manufacturer id (oxmanufacturers)',
                'type' => 'String',
            ),
            array(
                'id' => 'oxmanufacturers.OXTITLE',
                'name' => 'Manufacturer name',
                'description' => 'Manufacturer name',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXSKIPDISCOUNTS',
                'name' => 'Skips discounts',
                'description' => 'Skips all negative Discounts (Discounts, Vouchers, Delivery ...)',
                'type' => 'Boolean',
            ),
            array(
                'id' => 'oxarticles.OXRATING',
                'name' => 'Article rating',
                'description' => 'Article rating',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXMINDELTIME',
                'name' => 'Minimal delivery time',
                'description' => 'Minimal delivery time (unit is set in oxdeltimeunit)',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxarticles.OXMAXDELTIME',
                'name' => 'Maximum delivery time',
                'description' => 'Maximum delivery time (unit is set in oxdeltimeunit)',
                'type' => 'Integer',
            ),
            array(
                'id' => 'oxarticles.OXDELTIMEUNIT',
                'name' => 'Delivery time unit',
                'description' => 'Delivery time unit: DAY, WEEK, MONTH',
                'type' => 'String',
            ),
            array(
                'id' => 'oxarticles.OXUPDATEPRICE',
                'name' => 'Price update',
                'description' => 'If not 0, oxprice will be updated to this value on oxupdatepricetime date',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXUPDATEPRICEA',
                'name' => 'Price A update',
                'description' => 'If not 0, oxprice will be updated to this value on oxupdatepricetime date',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXUPDATEPRICEB',
                'name' => 'Price B update',
                'description' => 'If not 0, oxprice will be updated to this value on oxupdatepricetime date',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXUPDATEPRICEC',
                'name' => 'Price C update',
                'description' => 'If not 0, oxprice will be updated to this value on oxupdatepricetime date',
                'type' => 'Float',
            ),
            array(
                'id' => 'oxarticles.OXUPDATEPRICETIME',
                'name' => 'Price update date',
                'description' => 'Date, when oxprice[a,b,c] should be updated to oxupdateprice[a,b,c] values',
                'type' => 'Date',
            ),
            array(
                'id' => 'oxarticles.OXISDOWNLOADABLE',
                'name' => 'Download enabled',
                'description' => 'Enable download of files for this product',
                'type' => 'Boolean',
            ),
            array(
                'id' => 'oxarticles.OXSHOWCUSTOMAGREEMENT',
                'name' => 'Agreement check',
                'description' => 'Show custom agreement check in checkout',
                'type' => 'Boolean',
            ),
        );
    }

    private function createCustomersSelect($fieldIds)
    {
        $select = "SELECT oxuser.OXID as 'oxuser.OXID', ";
        foreach ($fieldIds as $field) {
            switch ($field) {
                case 'totalorders':
                case 'totalrevenue':
                case 'averagecartsize':
                case 'lastorder':
                case 'oxuser.OXID':
                    break;
                default:
                    $select .= $field . " as '" . $field . "', ";
                    break;
            }
        }

        return substr($select, 0, -2);
    }

    private function getOrderSelectFields($fieldIds)
    {
        $result = array();
        foreach ($fieldIds as $field) {
            switch ($field) {
                case 'totalorders':
                    $result[] = "count(oxorder.OXID) as '" . $field . "'";
                    break;
                case 'totalrevenue':
                    $result[] = "sum(oxorder.OXTOTALORDERSUM) as '" . $field . "'";
                    break;
                case 'averagecartsize':
                    $result[] = "avg(oxorder.OXTOTALORDERSUM) as '" . $field . "'";
                    break;
                case 'lastorder':
                    $result[] = "max(oxorder.OXORDERDATE) as '" . $field . "'";
                    break;
            }
        }
        
        return $result;
    }

    private function createProductSelect($attributeIds, $lang)
    {
        $select = "SELECT oxv_oxarticles_$lang.OXID AS 'oxarticles.OXID', ";
        foreach ($attributeIds as $attribute) {
            switch ($attribute) {
                case 'images':
                case 'link';
                case 'vat':
                case 'url':
                case 'oxarticles.OXID':
                    break;
                case 'newPriceNet':
                case 'oldPriceNet':
                case 'oldPrice':
                    $select .= "oxv_oxarticles_{$lang}.OXPRICE AS '$attribute', ";
                    break;
                default:
                    $strings = explode('.', $attribute);
                    $select .= "oxv_$strings[0]_$lang.$strings[1] AS '$attribute', ";
                    break;
            }
        }

        return substr($select, 0, -2);
    }

}
